<template>
    <tasks-item v-for="task of tasks" :key="task.id" :task="task" class="task" v-bind="$attrs"></tasks-item>
</template>

<script lang="ts">
import TasksItem from "@/components/Tasks/Item.vue";
import Task from "@/models/Task";
import { computed } from "@vue/runtime-core";

export default {
  components: { TasksItem },
  props: {
    tasks: {
      required: true,
      type: Array
    },
    itemClass: {
      required: false,
      type: String,
      default: ""
    },
    sort: {
      type: String,
      default: "none"
    }
  },
  setup(props) {
    const sorts = {
      none: () => 0,
      status: (a: Task, b: Task) => {
        if (a.status() == b.status()) {
          return 0;
        }
        if (a.isDo()) {
          return -1;
        }
        if (b.isDo()) {
          return 1;
        }
        if (a.isPending()) {
          return -1;
        }
        if (b.isPending()) {
          return 1;
        }
        if (a.isDone()) {
          return -1;
        }
        if (b.isDone()) {
          return 1;
        }
        return 0;
      }
    };

    return {
      tasks: computed(() => (props.tasks as Task[]).sort(sorts[props.sort as "none" | "status"]))
    };
  }
};
</script>

<style lang="stylus" scoped></style>
